

# AWS IoT Events
<a name="API_Operations_AWS_IoT_Events"></a>

The following actions are supported by AWS IoT Events:
+  [CreateAlarmModel](API_CreateAlarmModel.md) 
+  [CreateDetectorModel](API_CreateDetectorModel.md) 
+  [CreateInput](API_CreateInput.md) 
+  [DeleteAlarmModel](API_DeleteAlarmModel.md) 
+  [DeleteDetectorModel](API_DeleteDetectorModel.md) 
+  [DeleteInput](API_DeleteInput.md) 
+  [DescribeAlarmModel](API_DescribeAlarmModel.md) 
+  [DescribeDetectorModel](API_DescribeDetectorModel.md) 
+  [DescribeDetectorModelAnalysis](API_DescribeDetectorModelAnalysis.md) 
+  [DescribeInput](API_DescribeInput.md) 
+  [DescribeLoggingOptions](API_DescribeLoggingOptions.md) 
+  [GetDetectorModelAnalysisResults](API_GetDetectorModelAnalysisResults.md) 
+  [ListAlarmModels](API_ListAlarmModels.md) 
+  [ListAlarmModelVersions](API_ListAlarmModelVersions.md) 
+  [ListDetectorModels](API_ListDetectorModels.md) 
+  [ListDetectorModelVersions](API_ListDetectorModelVersions.md) 
+  [ListInputRoutings](API_ListInputRoutings.md) 
+  [ListInputs](API_ListInputs.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [PutLoggingOptions](API_PutLoggingOptions.md) 
+  [StartDetectorModelAnalysis](API_StartDetectorModelAnalysis.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateAlarmModel](API_UpdateAlarmModel.md) 
+  [UpdateDetectorModel](API_UpdateDetectorModel.md) 
+  [UpdateInput](API_UpdateInput.md) 

# CreateAlarmModel
<a name="API_CreateAlarmModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Creates an alarm model to monitor an AWS IoT Events input attribute. You can use the alarm to get notified when the value is outside a specified range. For more information, see [Create an alarm model](https://docs.aws.amazon.com/iotevents/latest/developerguide/create-alarms.html) in the * AWS IoT Events Developer Guide*.

## Request Syntax
<a name="API_CreateAlarmModel_RequestSyntax"></a>

```
POST /alarm-models HTTP/1.1
Content-type: application/json

{
   "alarmCapabilities": { 
      "acknowledgeFlow": { 
         "enabled": boolean
      },
      "initializationConfiguration": { 
         "disabledOnInitialization": boolean
      }
   },
   "alarmEventActions": { 
      "alarmActions": [ 
         { 
            "dynamoDB": { 
               "hashKeyField": "string",
               "hashKeyType": "string",
               "hashKeyValue": "string",
               "operation": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "payloadField": "string",
               "rangeKeyField": "string",
               "rangeKeyType": "string",
               "rangeKeyValue": "string",
               "tableName": "string"
            },
            "dynamoDBv2": { 
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "tableName": "string"
            },
            "firehose": { 
               "deliveryStreamName": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "separator": "string"
            },
            "iotEvents": { 
               "inputName": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               }
            },
            "iotSiteWise": { 
               "assetId": "string",
               "entryId": "string",
               "propertyAlias": "string",
               "propertyId": "string",
               "propertyValue": { 
                  "quality": "string",
                  "timestamp": { 
                     "offsetInNanos": "string",
                     "timeInSeconds": "string"
                  },
                  "value": { 
                     "booleanValue": "string",
                     "doubleValue": "string",
                     "integerValue": "string",
                     "stringValue": "string"
                  }
               }
            },
            "iotTopicPublish": { 
               "mqttTopic": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               }
            },
            "lambda": { 
               "functionArn": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               }
            },
            "sns": { 
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "targetArn": "string"
            },
            "sqs": { 
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "queueUrl": "string",
               "useBase64": boolean
            }
         }
      ]
   },
   "alarmModelDescription": "string",
   "alarmModelName": "string",
   "alarmNotification": { 
      "notificationActions": [ 
         { 
            "action": { 
               "lambdaAction": { 
                  "functionArn": "string",
                  "payload": { 
                     "contentExpression": "string",
                     "type": "string"
                  }
               }
            },
            "emailConfigurations": [ 
               { 
                  "content": { 
                     "additionalMessage": "string",
                     "subject": "string"
                  },
                  "from": "string",
                  "recipients": { 
                     "to": [ 
                        { 
                           "ssoIdentity": { 
                              "identityStoreId": "string",
                              "userId": "string"
                           }
                        }
                     ]
                  }
               }
            ],
            "smsConfigurations": [ 
               { 
                  "additionalMessage": "string",
                  "recipients": [ 
                     { 
                        "ssoIdentity": { 
                           "identityStoreId": "string",
                           "userId": "string"
                        }
                     }
                  ],
                  "senderId": "string"
               }
            ]
         }
      ]
   },
   "alarmRule": { 
      "simpleRule": { 
         "comparisonOperator": "string",
         "inputProperty": "string",
         "threshold": "string"
      }
   },
   "key": "string",
   "roleArn": "string",
   "severity": number,
   "tags": [ 
      { 
         "key": "string",
         "value": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_CreateAlarmModel_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateAlarmModel_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [alarmCapabilities](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-alarmCapabilities"></a>
Contains the configuration information of alarm state changes.  
Type: [AlarmCapabilities](API_AlarmCapabilities.md) object  
Required: No

 ** [alarmEventActions](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-alarmEventActions"></a>
Contains information about one or more alarm actions.  
Type: [AlarmEventActions](API_AlarmEventActions.md) object  
Required: No

 ** [alarmModelDescription](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-alarmModelDescription"></a>
A description that tells you what the alarm model detects.  
Type: String  
Length Constraints: Maximum length of 1024.  
Required: No

 ** [alarmModelName](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-alarmModelName"></a>
A unique name that helps you identify the alarm model. You can't change this name after you create the alarm model.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [alarmNotification](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-alarmNotification"></a>
Contains information about one or more notification actions.  
Type: [AlarmNotification](API_AlarmNotification.md) object  
Required: No

 ** [alarmRule](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-alarmRule"></a>
Defines when your alarm is invoked.  
Type: [AlarmRule](API_AlarmRule.md) object  
Required: Yes

 ** [key](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-key"></a>
An input attribute used as a key to create an alarm. AWS IoT Events routes [inputs](https://docs.aws.amazon.com/iotevents/latest/apireference/API_Input.html) associated with this key to the alarm.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^((`[\w\- ]+`)|([\w\-]+))(\.((`[\w- ]+`)|([\w\-]+)))*$`   
Required: No

 ** [roleArn](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-roleArn"></a>
The ARN of the IAM role that allows the alarm to perform actions and access AWS resources. For more information, see [Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference*.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Required: Yes

 ** [severity](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-severity"></a>
A non-negative integer that reflects the severity level of the alarm.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2147483647.  
Required: No

 ** [tags](#API_CreateAlarmModel_RequestSyntax) **   <a name="iotevents-CreateAlarmModel-request-tags"></a>
A list of key-value pairs that contain metadata for the alarm model. The tags help you manage the alarm model. For more information, see [Tagging your AWS IoT Events resources](https://docs.aws.amazon.com/iotevents/latest/developerguide/tagging-iotevents.html) in the * AWS IoT Events Developer Guide*.  
You can create up to 50 tags for one alarm model.  
Type: Array of [Tag](API_Tag.md) objects  
Required: No

## Response Syntax
<a name="API_CreateAlarmModel_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "alarmModelArn": "string",
   "alarmModelVersion": "string",
   "creationTime": number,
   "lastUpdateTime": number,
   "status": "string"
}
```

## Response Elements
<a name="API_CreateAlarmModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [alarmModelArn](#API_CreateAlarmModel_ResponseSyntax) **   <a name="iotevents-CreateAlarmModel-response-alarmModelArn"></a>
The ARN of the alarm model. For more information, see [Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference*.  
Type: String

 ** [alarmModelVersion](#API_CreateAlarmModel_ResponseSyntax) **   <a name="iotevents-CreateAlarmModel-response-alarmModelVersion"></a>
The version of the alarm model.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.

 ** [creationTime](#API_CreateAlarmModel_ResponseSyntax) **   <a name="iotevents-CreateAlarmModel-response-creationTime"></a>
The time the alarm model was created, in the Unix epoch format.  
Type: Timestamp

 ** [lastUpdateTime](#API_CreateAlarmModel_ResponseSyntax) **   <a name="iotevents-CreateAlarmModel-response-lastUpdateTime"></a>
The time the alarm model was last updated, in the Unix epoch format.  
Type: Timestamp

 ** [status](#API_CreateAlarmModel_ResponseSyntax) **   <a name="iotevents-CreateAlarmModel-response-status"></a>
The status of the alarm model. The status can be one of the following values:  
+  `ACTIVE` - The alarm model is active and it's ready to evaluate data.
+  `ACTIVATING` - AWS IoT Events is activating your alarm model. Activating an alarm model can take up to a few minutes.
+  `INACTIVE` - The alarm model is inactive, so it isn't ready to evaluate data. Check your alarm model information and update the alarm model.
+  `FAILED` - You couldn't create or update the alarm model. Check your alarm model information and try again.
Type: String  
Valid Values: `ACTIVE | ACTIVATING | INACTIVE | FAILED` 

## Errors
<a name="API_CreateAlarmModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** LimitExceededException **   
A limit was exceeded.    
 ** message **   
The message for the exception.
HTTP Status Code: 410

 ** ResourceAlreadyExistsException **   
The resource already exists.    
 ** message **   
The message for the exception.  
 ** resourceArn **   
The ARN of the resource.  
 ** resourceId **   
The ID of the resource.
HTTP Status Code: 409

 ** ResourceInUseException **   
The resource is in use.    
 ** message **   
The message for the exception.
HTTP Status Code: 409

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_CreateAlarmModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/CreateAlarmModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/CreateAlarmModel) 

# CreateDetectorModel
<a name="API_CreateDetectorModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Creates a detector model.

## Request Syntax
<a name="API_CreateDetectorModel_RequestSyntax"></a>

```
POST /detector-models HTTP/1.1
Content-type: application/json

{
   "detectorModelDefinition": { 
      "initialStateName": "string",
      "states": [ 
         { 
            "onEnter": { 
               "events": [ 
                  { 
                     "actions": [ 
                        { 
                           "clearTimer": { 
                              "timerName": "string"
                           },
                           "dynamoDB": { 
                              "hashKeyField": "string",
                              "hashKeyType": "string",
                              "hashKeyValue": "string",
                              "operation": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "payloadField": "string",
                              "rangeKeyField": "string",
                              "rangeKeyType": "string",
                              "rangeKeyValue": "string",
                              "tableName": "string"
                           },
                           "dynamoDBv2": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "tableName": "string"
                           },
                           "firehose": { 
                              "deliveryStreamName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "separator": "string"
                           },
                           "iotEvents": { 
                              "inputName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "iotSiteWise": { 
                              "assetId": "string",
                              "entryId": "string",
                              "propertyAlias": "string",
                              "propertyId": "string",
                              "propertyValue": { 
                                 "quality": "string",
                                 "timestamp": { 
                                    "offsetInNanos": "string",
                                    "timeInSeconds": "string"
                                 },
                                 "value": { 
                                    "booleanValue": "string",
                                    "doubleValue": "string",
                                    "integerValue": "string",
                                    "stringValue": "string"
                                 }
                              }
                           },
                           "iotTopicPublish": { 
                              "mqttTopic": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "lambda": { 
                              "functionArn": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "resetTimer": { 
                              "timerName": "string"
                           },
                           "setTimer": { 
                              "durationExpression": "string",
                              "seconds": number,
                              "timerName": "string"
                           },
                           "setVariable": { 
                              "value": "string",
                              "variableName": "string"
                           },
                           "sns": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "targetArn": "string"
                           },
                           "sqs": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "queueUrl": "string",
                              "useBase64": boolean
                           }
                        }
                     ],
                     "condition": "string",
                     "eventName": "string"
                  }
               ]
            },
            "onExit": { 
               "events": [ 
                  { 
                     "actions": [ 
                        { 
                           "clearTimer": { 
                              "timerName": "string"
                           },
                           "dynamoDB": { 
                              "hashKeyField": "string",
                              "hashKeyType": "string",
                              "hashKeyValue": "string",
                              "operation": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "payloadField": "string",
                              "rangeKeyField": "string",
                              "rangeKeyType": "string",
                              "rangeKeyValue": "string",
                              "tableName": "string"
                           },
                           "dynamoDBv2": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "tableName": "string"
                           },
                           "firehose": { 
                              "deliveryStreamName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "separator": "string"
                           },
                           "iotEvents": { 
                              "inputName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "iotSiteWise": { 
                              "assetId": "string",
                              "entryId": "string",
                              "propertyAlias": "string",
                              "propertyId": "string",
                              "propertyValue": { 
                                 "quality": "string",
                                 "timestamp": { 
                                    "offsetInNanos": "string",
                                    "timeInSeconds": "string"
                                 },
                                 "value": { 
                                    "booleanValue": "string",
                                    "doubleValue": "string",
                                    "integerValue": "string",
                                    "stringValue": "string"
                                 }
                              }
                           },
                           "iotTopicPublish": { 
                              "mqttTopic": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "lambda": { 
                              "functionArn": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "resetTimer": { 
                              "timerName": "string"
                           },
                           "setTimer": { 
                              "durationExpression": "string",
                              "seconds": number,
                              "timerName": "string"
                           },
                           "setVariable": { 
                              "value": "string",
                              "variableName": "string"
                           },
                           "sns": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "targetArn": "string"
                           },
                           "sqs": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "queueUrl": "string",
                              "useBase64": boolean
                           }
                        }
                     ],
                     "condition": "string",
                     "eventName": "string"
                  }
               ]
            },
            "onInput": { 
               "events": [ 
                  { 
                     "actions": [ 
                        { 
                           "clearTimer": { 
                              "timerName": "string"
                           },
                           "dynamoDB": { 
                              "hashKeyField": "string",
                              "hashKeyType": "string",
                              "hashKeyValue": "string",
                              "operation": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "payloadField": "string",
                              "rangeKeyField": "string",
                              "rangeKeyType": "string",
                              "rangeKeyValue": "string",
                              "tableName": "string"
                           },
                           "dynamoDBv2": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "tableName": "string"
                           },
                           "firehose": { 
                              "deliveryStreamName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "separator": "string"
                           },
                           "iotEvents": { 
                              "inputName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "iotSiteWise": { 
                              "assetId": "string",
                              "entryId": "string",
                              "propertyAlias": "string",
                              "propertyId": "string",
                              "propertyValue": { 
                                 "quality": "string",
                                 "timestamp": { 
                                    "offsetInNanos": "string",
                                    "timeInSeconds": "string"
                                 },
                                 "value": { 
                                    "booleanValue": "string",
                                    "doubleValue": "string",
                                    "integerValue": "string",
                                    "stringValue": "string"
                                 }
                              }
                           },
                           "iotTopicPublish": { 
                              "mqttTopic": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "lambda": { 
                              "functionArn": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "resetTimer": { 
                              "timerName": "string"
                           },
                           "setTimer": { 
                              "durationExpression": "string",
                              "seconds": number,
                              "timerName": "string"
                           },
                           "setVariable": { 
                              "value": "string",
                              "variableName": "string"
                           },
                           "sns": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "targetArn": "string"
                           },
                           "sqs": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "queueUrl": "string",
                              "useBase64": boolean
                           }
                        }
                     ],
                     "condition": "string",
                     "eventName": "string"
                  }
               ],
               "transitionEvents": [ 
                  { 
                     "actions": [ 
                        { 
                           "clearTimer": { 
                              "timerName": "string"
                           },
                           "dynamoDB": { 
                              "hashKeyField": "string",
                              "hashKeyType": "string",
                              "hashKeyValue": "string",
                              "operation": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "payloadField": "string",
                              "rangeKeyField": "string",
                              "rangeKeyType": "string",
                              "rangeKeyValue": "string",
                              "tableName": "string"
                           },
                           "dynamoDBv2": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "tableName": "string"
                           },
                           "firehose": { 
                              "deliveryStreamName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "separator": "string"
                           },
                           "iotEvents": { 
                              "inputName": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "iotSiteWise": { 
                              "assetId": "string",
                              "entryId": "string",
                              "propertyAlias": "string",
                              "propertyId": "string",
                              "propertyValue": { 
                                 "quality": "string",
                                 "timestamp": { 
                                    "offsetInNanos": "string",
                                    "timeInSeconds": "string"
                                 },
                                 "value": { 
                                    "booleanValue": "string",
                                    "doubleValue": "string",
                                    "integerValue": "string",
                                    "stringValue": "string"
                                 }
                              }
                           },
                           "iotTopicPublish": { 
                              "mqttTopic": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "lambda": { 
                              "functionArn": "string",
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              }
                           },
                           "resetTimer": { 
                              "timerName": "string"
                           },
                           "setTimer": { 
                              "durationExpression": "string",
                              "seconds": number,
                              "timerName": "string"
                           },
                           "setVariable": { 
                              "value": "string",
                              "variableName": "string"
                           },
                           "sns": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "targetArn": "string"
                           },
                           "sqs": { 
                              "payload": { 
                                 "contentExpression": "string",
                                 "type": "string"
                              },
                              "queueUrl": "string",
                              "useBase64": boolean
                           }
                        }
                     ],
                     "condition": "string",
                     "eventName": "string",
                     "nextState": "string"
                  }
               ]
            },
            "stateName": "string"
         }
      ]
   },
   "detectorModelDescription": "string",
   "detectorModelName": "string",
   "evaluationMethod": "string",
   "key": "string",
   "roleArn": "string",
   "tags": [ 
      { 
         "key": "string",
         "value": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_CreateDetectorModel_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateDetectorModel_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [detectorModelDefinition](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-detectorModelDefinition"></a>
Information that defines how the detectors operate.  
Type: [DetectorModelDefinition](API_DetectorModelDefinition.md) object  
Required: Yes

 ** [detectorModelDescription](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-detectorModelDescription"></a>
A brief description of the detector model.  
Type: String  
Length Constraints: Maximum length of 1024.  
Required: No

 ** [detectorModelName](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-detectorModelName"></a>
The name of the detector model.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [evaluationMethod](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-evaluationMethod"></a>
Information about the order in which events are evaluated and how actions are executed.   
Default: `BATCH`   
Type: String  
Valid Values: `BATCH | SERIAL`   
Required: No

 ** [key](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-key"></a>
The input attribute key used to identify a device or system to create a detector (an instance of the detector model) and then to route each input received to the appropriate detector (instance). This parameter uses a JSON-path expression in the message payload of each input to specify the attribute-value pair that is used to identify the device associated with the input.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^((`[\w\- ]+`)|([\w\-]+))(\.((`[\w- ]+`)|([\w\-]+)))*$`   
Required: No

 ** [roleArn](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-roleArn"></a>
The ARN of the role that grants permission to AWS IoT Events to perform its operations.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Required: Yes

 ** [tags](#API_CreateDetectorModel_RequestSyntax) **   <a name="iotevents-CreateDetectorModel-request-tags"></a>
Metadata that can be used to manage the detector model.  
Type: Array of [Tag](API_Tag.md) objects  
Required: No

## Response Syntax
<a name="API_CreateDetectorModel_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "detectorModelConfiguration": { 
      "creationTime": number,
      "detectorModelArn": "string",
      "detectorModelDescription": "string",
      "detectorModelName": "string",
      "detectorModelVersion": "string",
      "evaluationMethod": "string",
      "key": "string",
      "lastUpdateTime": number,
      "roleArn": "string",
      "status": "string"
   }
}
```

## Response Elements
<a name="API_CreateDetectorModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [detectorModelConfiguration](#API_CreateDetectorModel_ResponseSyntax) **   <a name="iotevents-CreateDetectorModel-response-detectorModelConfiguration"></a>
Information about how the detector model is configured.  
Type: [DetectorModelConfiguration](API_DetectorModelConfiguration.md) object

## Errors
<a name="API_CreateDetectorModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** LimitExceededException **   
A limit was exceeded.    
 ** message **   
The message for the exception.
HTTP Status Code: 410

 ** ResourceAlreadyExistsException **   
The resource already exists.    
 ** message **   
The message for the exception.  
 ** resourceArn **   
The ARN of the resource.  
 ** resourceId **   
The ID of the resource.
HTTP Status Code: 409

 ** ResourceInUseException **   
The resource is in use.    
 ** message **   
The message for the exception.
HTTP Status Code: 409

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_CreateDetectorModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/CreateDetectorModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/CreateDetectorModel) 

# CreateInput
<a name="API_CreateInput"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Creates an input.

## Request Syntax
<a name="API_CreateInput_RequestSyntax"></a>

```
POST /inputs HTTP/1.1
Content-type: application/json

{
   "inputDefinition": { 
      "attributes": [ 
         { 
            "jsonPath": "string"
         }
      ]
   },
   "inputDescription": "string",
   "inputName": "string",
   "tags": [ 
      { 
         "key": "string",
         "value": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_CreateInput_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateInput_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [inputDefinition](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-inputDefinition"></a>
The definition of the input.  
Type: [InputDefinition](API_InputDefinition.md) object  
Required: Yes

 ** [inputDescription](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-inputDescription"></a>
A brief description of the input.  
Type: String  
Length Constraints: Maximum length of 1024.  
Required: No

 ** [inputName](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-inputName"></a>
The name you want to give to the input.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z][a-zA-Z0-9_]*$`   
Required: Yes

 ** [tags](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-tags"></a>
Metadata that can be used to manage the input.  
Type: Array of [Tag](API_Tag.md) objects  
Required: No

## Response Syntax
<a name="API_CreateInput_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "inputConfiguration": { 
      "creationTime": number,
      "inputArn": "string",
      "inputDescription": "string",
      "inputName": "string",
      "lastUpdateTime": number,
      "status": "string"
   }
}
```

## Response Elements
<a name="API_CreateInput_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [inputConfiguration](#API_CreateInput_ResponseSyntax) **   <a name="iotevents-CreateInput-response-inputConfiguration"></a>
Information about the configuration of the input.  
Type: [InputConfiguration](API_InputConfiguration.md) object

## Errors
<a name="API_CreateInput_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceAlreadyExistsException **   
The resource already exists.    
 ** message **   
The message for the exception.  
 ** resourceArn **   
The ARN of the resource.  
 ** resourceId **   
The ID of the resource.
HTTP Status Code: 409

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_CreateInput_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/CreateInput) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/CreateInput) 

# DeleteAlarmModel
<a name="API_DeleteAlarmModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Deletes an alarm model. Any alarm instances that were created based on this alarm model are also deleted. This action can't be undone.

## Request Syntax
<a name="API_DeleteAlarmModel_RequestSyntax"></a>

```
DELETE /alarm-models/alarmModelName HTTP/1.1
```

## URI Request Parameters
<a name="API_DeleteAlarmModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [alarmModelName](#API_DeleteAlarmModel_RequestSyntax) **   <a name="iotevents-DeleteAlarmModel-request-uri-alarmModelName"></a>
The name of the alarm model.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

## Request Body
<a name="API_DeleteAlarmModel_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DeleteAlarmModel_ResponseSyntax"></a>

```
HTTP/1.1 204
```

## Response Elements
<a name="API_DeleteAlarmModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 204 response with an empty HTTP body.

## Errors
<a name="API_DeleteAlarmModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceInUseException **   
The resource is in use.    
 ** message **   
The message for the exception.
HTTP Status Code: 409

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_DeleteAlarmModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/DeleteAlarmModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/DeleteAlarmModel) 

# DeleteDetectorModel
<a name="API_DeleteDetectorModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Deletes a detector model. Any active instances of the detector model are also deleted.

## Request Syntax
<a name="API_DeleteDetectorModel_RequestSyntax"></a>

```
DELETE /detector-models/detectorModelName HTTP/1.1
```

## URI Request Parameters
<a name="API_DeleteDetectorModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [detectorModelName](#API_DeleteDetectorModel_RequestSyntax) **   <a name="iotevents-DeleteDetectorModel-request-uri-detectorModelName"></a>
The name of the detector model to be deleted.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

## Request Body
<a name="API_DeleteDetectorModel_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DeleteDetectorModel_ResponseSyntax"></a>

```
HTTP/1.1 204
```

## Response Elements
<a name="API_DeleteDetectorModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 204 response with an empty HTTP body.

## Errors
<a name="API_DeleteDetectorModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceInUseException **   
The resource is in use.    
 ** message **   
The message for the exception.
HTTP Status Code: 409

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_DeleteDetectorModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/DeleteDetectorModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/DeleteDetectorModel) 

# DeleteInput
<a name="API_DeleteInput"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Deletes an input.

## Request Syntax
<a name="API_DeleteInput_RequestSyntax"></a>

```
DELETE /inputs/inputName HTTP/1.1
```

## URI Request Parameters
<a name="API_DeleteInput_RequestParameters"></a>

The request uses the following URI parameters.

 ** [inputName](#API_DeleteInput_RequestSyntax) **   <a name="iotevents-DeleteInput-request-uri-inputName"></a>
The name of the input to delete.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z][a-zA-Z0-9_]*$`   
Required: Yes

## Request Body
<a name="API_DeleteInput_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DeleteInput_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_DeleteInput_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_DeleteInput_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceInUseException **   
The resource is in use.    
 ** message **   
The message for the exception.
HTTP Status Code: 409

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_DeleteInput_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/DeleteInput) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/DeleteInput) 

# DescribeAlarmModel
<a name="API_DescribeAlarmModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Retrieves information about an alarm model. If you don't specify a value for the `alarmModelVersion` parameter, the latest version is returned.

## Request Syntax
<a name="API_DescribeAlarmModel_RequestSyntax"></a>

```
GET /alarm-models/alarmModelName?version=alarmModelVersion HTTP/1.1
```

## URI Request Parameters
<a name="API_DescribeAlarmModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [alarmModelName](#API_DescribeAlarmModel_RequestSyntax) **   <a name="iotevents-DescribeAlarmModel-request-uri-alarmModelName"></a>
The name of the alarm model.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [alarmModelVersion](#API_DescribeAlarmModel_RequestSyntax) **   <a name="iotevents-DescribeAlarmModel-request-uri-alarmModelVersion"></a>
The version of the alarm model.  
Length Constraints: Minimum length of 1. Maximum length of 128.

## Request Body
<a name="API_DescribeAlarmModel_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DescribeAlarmModel_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "alarmCapabilities": { 
      "acknowledgeFlow": { 
         "enabled": boolean
      },
      "initializationConfiguration": { 
         "disabledOnInitialization": boolean
      }
   },
   "alarmEventActions": { 
      "alarmActions": [ 
         { 
            "dynamoDB": { 
               "hashKeyField": "string",
               "hashKeyType": "string",
               "hashKeyValue": "string",
               "operation": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "payloadField": "string",
               "rangeKeyField": "string",
               "rangeKeyType": "string",
               "rangeKeyValue": "string",
               "tableName": "string"
            },
            "dynamoDBv2": { 
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "tableName": "string"
            },
            "firehose": { 
               "deliveryStreamName": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "separator": "string"
            },
            "iotEvents": { 
               "inputName": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               }
            },
            "iotSiteWise": { 
               "assetId": "string",
               "entryId": "string",
               "propertyAlias": "string",
               "propertyId": "string",
               "propertyValue": { 
                  "quality": "string",
                  "timestamp": { 
                     "offsetInNanos": "string",
                     "timeInSeconds": "string"
                  },
                  "value": { 
                     "booleanValue": "string",
                     "doubleValue": "string",
                     "integerValue": "string",
                     "stringValue": "string"
                  }
               }
            },
            "iotTopicPublish": { 
               "mqttTopic": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               }
            },
            "lambda": { 
               "functionArn": "string",
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               }
            },
            "sns": { 
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "targetArn": "string"
            },
            "sqs": { 
               "payload": { 
                  "contentExpression": "string",
                  "type": "string"
               },
               "queueUrl": "string",
               "useBase64": boolean
            }
         }
      ]
   },
   "alarmModelArn": "string",
   "alarmModelDescription": "string",
   "alarmModelName": "string",
   "alarmModelVersion": "string",
   "alarmNotification": { 
      "notificationActions": [ 
         { 
            "action": { 
               "lambdaAction": { 
                  "functionArn": "string",
                  "payload": { 
                     "contentExpression": "string",
                     "type": "string"
                  }
               }
            },
            "emailConfigurations": [ 
               { 
                  "content": { 
                     "additionalMessage": "string",
                     "subject": "string"
                  },
                  "from": "string",
                  "recipients": { 
                     "to": [ 
                        { 
                           "ssoIdentity": { 
                              "identityStoreId": "string",
                              "userId": "string"
                           }
                        }
                     ]
                  }
               }
            ],
            "smsConfigurations": [ 
               { 
                  "additionalMessage": "string",
                  "recipients": [ 
                     { 
                        "ssoIdentity": { 
                           "identityStoreId": "string",
                           "userId": "string"
                        }
                     }
                  ],
                  "senderId": "string"
               }
            ]
         }
      ]
   },
   "alarmRule": { 
      "simpleRule": { 
         "comparisonOperator": "string",
         "inputProperty": "string",
         "threshold": "string"
      }
   },
   "creationTime": number,
   "key": "string",
   "lastUpdateTime": number,
   "roleArn": "string",
   "severity": number,
   "status": "string",
   "statusMessage": "string"
}
```

## Response Elements
<a name="API_DescribeAlarmModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [alarmCapabilities](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmCapabilities"></a>
Contains the configuration information of alarm state changes.  
Type: [AlarmCapabilities](API_AlarmCapabilities.md) object

 ** [alarmEventActions](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmEventActions"></a>
Contains information about one or more alarm actions.  
Type: [AlarmEventActions](API_AlarmEventActions.md) object

 ** [alarmModelArn](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmModelArn"></a>
The ARN of the alarm model. For more information, see [Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference*.  
Type: String

 ** [alarmModelDescription](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmModelDescription"></a>
The description of the alarm model.  
Type: String  
Length Constraints: Maximum length of 1024.

 ** [alarmModelName](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmModelName"></a>
The name of the alarm model.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$` 

 ** [alarmModelVersion](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmModelVersion"></a>
The version of the alarm model.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.

 ** [alarmNotification](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmNotification"></a>
Contains information about one or more notification actions.  
Type: [AlarmNotification](API_AlarmNotification.md) object

 ** [alarmRule](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-alarmRule"></a>
Defines when your alarm is invoked.  
Type: [AlarmRule](API_AlarmRule.md) object

 ** [creationTime](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-creationTime"></a>
The time the alarm model was created, in the Unix epoch format.  
Type: Timestamp

 ** [key](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-key"></a>
An input attribute used as a key to create an alarm. AWS IoT Events routes [inputs](https://docs.aws.amazon.com/iotevents/latest/apireference/API_Input.html) associated with this key to the alarm.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^((`[\w\- ]+`)|([\w\-]+))(\.((`[\w- ]+`)|([\w\-]+)))*$` 

 ** [lastUpdateTime](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-lastUpdateTime"></a>
The time the alarm model was last updated, in the Unix epoch format.  
Type: Timestamp

 ** [roleArn](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-roleArn"></a>
The ARN of the IAM role that allows the alarm to perform actions and access AWS resources. For more information, see [Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference*.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.

 ** [severity](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-severity"></a>
A non-negative integer that reflects the severity level of the alarm.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 2147483647.

 ** [status](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-status"></a>
The status of the alarm model. The status can be one of the following values:  
+  `ACTIVE` - The alarm model is active and it's ready to evaluate data.
+  `ACTIVATING` - AWS IoT Events is activating your alarm model. Activating an alarm model can take up to a few minutes.
+  `INACTIVE` - The alarm model is inactive, so it isn't ready to evaluate data. Check your alarm model information and update the alarm model.
+  `FAILED` - You couldn't create or update the alarm model. Check your alarm model information and try again.
Type: String  
Valid Values: `ACTIVE | ACTIVATING | INACTIVE | FAILED` 

 ** [statusMessage](#API_DescribeAlarmModel_ResponseSyntax) **   <a name="iotevents-DescribeAlarmModel-response-statusMessage"></a>
 Contains information about the status of the alarm model.   
Type: String

## Errors
<a name="API_DescribeAlarmModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_DescribeAlarmModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/DescribeAlarmModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/DescribeAlarmModel) 

# DescribeDetectorModel
<a name="API_DescribeDetectorModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Describes a detector model. If the `version` parameter is not specified, information about the latest version is returned.

## Request Syntax
<a name="API_DescribeDetectorModel_RequestSyntax"></a>

```
GET /detector-models/detectorModelName?version=detectorModelVersion HTTP/1.1
```

## URI Request Parameters
<a name="API_DescribeDetectorModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [detectorModelName](#API_DescribeDetectorModel_RequestSyntax) **   <a name="iotevents-DescribeDetectorModel-request-uri-detectorModelName"></a>
The name of the detector model.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [detectorModelVersion](#API_DescribeDetectorModel_RequestSyntax) **   <a name="iotevents-DescribeDetectorModel-request-uri-detectorModelVersion"></a>
The version of the detector model.  
Length Constraints: Minimum length of 1. Maximum length of 128.

## Request Body
<a name="API_DescribeDetectorModel_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DescribeDetectorModel_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "detectorModel": { 
      "detectorModelConfiguration": { 
         "creationTime": number,
         "detectorModelArn": "string",
         "detectorModelDescription": "string",
         "detectorModelName": "string",
         "detectorModelVersion": "string",
         "evaluationMethod": "string",
         "key": "string",
         "lastUpdateTime": number,
         "roleArn": "string",
         "status": "string"
      },
      "detectorModelDefinition": { 
         "initialStateName": "string",
         "states": [ 
            { 
               "onEnter": { 
                  "events": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string"
                     }
                  ]
               },
               "onExit": { 
                  "events": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string"
                     }
                  ]
               },
               "onInput": { 
                  "events": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string"
                     }
                  ],
                  "transitionEvents": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string",
                        "nextState": "string"
                     }
                  ]
               },
               "stateName": "string"
            }
         ]
      }
   }
}
```

## Response Elements
<a name="API_DescribeDetectorModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [detectorModel](#API_DescribeDetectorModel_ResponseSyntax) **   <a name="iotevents-DescribeDetectorModel-response-detectorModel"></a>
Information about the detector model.  
Type: [DetectorModel](API_DetectorModel.md) object

## Errors
<a name="API_DescribeDetectorModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_DescribeDetectorModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/DescribeDetectorModel) 
[...]
